#!/usr/bin/perl

use strict;
use Asterisk::AGI;

# directory to find .pagi's
my $PAGI_DIR = "/var/lib/asterisk/agi-bin/pagi";

# should we debug?
my $DEBUG = 0;

# reload pagis on hup
$SIG{'HUP'} = \&read_pagis;

# global functions
my %functions;

sub read_pagis
{
	debug("Reading in PAGIs");
	%functions = ();

	opendir(PAGI, $PAGI_DIR) || die "Unable to open $PAGI_DIR: $!";
	foreach my $pl (grep { /\.pagi$/ } readdir(PAGI))
	{
		if ($pl =~ /^(.*)\.pagi$/)
		{
			$functions{$1} = do($PAGI_DIR . "/$pl");
		}
	}
	closedir(PAGI);
}

read_pagis();
# read in agi params
while (1)
{
	chomp(my $url = <STDIN>);
	$url =~ s$^(?:agi|fon)://[\d.:]+/$$;

	my ($func, $params) = split(/\?/, $url, 2);
	$func =~ s/\.pagi$//;
	my %params = map { (split(/=/, $_, 2))[0, 1] } split(/&/, $params);

print "calling $func\n";
	# evaluate users function
	eval { &{$functions{$func}}(undef, %params); };
}


sub get_var
{
	my ($self, $field) = @_;

	print "GET VARIABLE " . uc($field) . "\n";
	my $data = <STDIN>;

	# got data back
	if (substr($data, 0, 14) eq "200 result=1 (")
	{
		return substr($data, 14, index($data, ")") - 14);
	}
	return undef;
}

sub debug
{
	print localtime() . ": $_[0]\n";
}
